#!/bin/bash
PATH_TO_TOKENS_LDAP_NET="/var/lib/llxcfg-ldap/aclnet"
_set_acls_net(){
	# SET ACLS FOR STUDENTS
	RECURSIVE=""
	HOMESTUDENTS="/net/home/students"
	[ -d "$HOMESTUDENTS" ] || mkdir -p "$HOMESTUDENTS"
	DCOUNT="$(ls "$HOMESTUDENTS" | wc -w)"
	echo "setfacl -k -b -R $HOMESTUDENTS"
	setfacl -k -b -R $HOMESTUDENTS
	if [ -e "$PATH_TO_TOKENS_LDAP_NET" ] ; then
		rm "$PATH_TO_TOKENS_LDAP_NET"
	fi
	if [ "$DCOUNT" != "0" ]; then
		RECURSIVE="-R"
		echo "setfacl $RECURSIVE -m g:teachers:rwx $HOMESTUDENTS"
		setfacl $RECURSIVE -m g:teachers:rwx $HOMESTUDENTS || true
		echo "setfacl $RECURSIVE -m g:admin:rwx $HOMESTUDENTS"
		setfacl $RECURSIVE -m g:admin:rwx $HOMESTUDENTS || true
	fi
	echo "setfacl $RECURSIVE -d -m g:teachers:rwx $HOMESTUDENTS"
	setfacl $RECURSIVE -d -m g:teachers:rwx $HOMESTUDENTS || true
	echo "setfacl $RECURSIVE -d -m g:admin:rwx $HOMESTUDENTS"
	setfacl $RECURSIVE -d -m g:admin:rwx $HOMESTUDENTS || true
	echo "setfacl $RECURSIVE -d -m u::rwx $HOMESTUDENTS"
	setfacl $RECURSIVE -d -m u::rwx $HOMESTUDENTS || true
	echo "setfacl $RECURSIVE -d -m g::--- $HOMESTUDENTS"
	setfacl $RECURSIVE -d -m g::--- $HOMESTUDENTS || true
	echo "setfacl $RECURSIVE -d -m o::--- $HOMESTUDENTS"
	setfacl $RECURSIVE -d -m o::--- $HOMESTUDENTS || true
	echo "setfacl $RECURSIVE -d -m m::rwx $HOMESTUDENTS"
	setfacl $RECURSIVE -d -m m::rwx $HOMESTUDENTS || true
	RECURSIVE=""
	HOMEOTHER="/net/home/others"
	[ -d "$HOMEOTHER" ] || mkdir -p "$HOMEOTHER"
	DCOUNT="$(ls "$HOMEOTHER" | wc -w)"
	setfacl -k -b -R $HOMEOTHER
	if [ "$DCOUNT" != "0" ]; then
		RECURSIVE="-R"
		echo "setfacl $RECURSIVE -m g:teachers:rwx $HOMEOTHER"
		setfacl $RECURSIVE -m g:teachers:rwx $HOMEOTHER || true
		echo "setfacl $RECURSIVE -m g:admin:rwx $HOMEOTHER"
		setfacl $RECURSIVE -m g:admin:rwx $HOMEOTHER || true
	fi
	echo "setfacl $RECURSIVE -d -m g:teachers:rwx $HOMEOTHER"
	setfacl $RECURSIVE -d -m g:teachers:rwx $HOMEOTHER || true
	echo "setfacl $RECURSIVE -d -m g:admin:rwx $HOMEOTHER"
	setfacl $RECURSIVE -d -m g:admin:rwx $HOMEOTHER || true
	echo "setfacl $RECURSIVE -d -m u::rwx $HOMEOTHER"
	setfacl $RECURSIVE -d -m u::rwx $HOMEOTHER || true
	echo "setfacl $RECURSIVE -d -m g::--- $HOMEOTHER"
	setfacl $RECURSIVE -d -m g::--- $HOMEOTHER || true
	echo "setfacl $RECURSIVE -d -m o::--- $HOMEOTHER"
	setfacl $RECURSIVE -d -m o::--- $HOMEOTHER || true
	echo "setfacl $RECURSIVE -d -m m::rwx $HOMEOTHER"
	setfacl $RECURSIVE -d -m m::rwx $HOMEOTHER || true
	RECURSIVE=""
	HOMETEACHERS="/net/home/teachers"
	[ -d "$HOMETEACHERS" ] || mkdir -p "$HOMETEACHERS"
	DCOUNT="$(ls "$HOMETEACHERS" | wc -w)"
	setfacl -k -b -R $HOMETEACHERS
	if [ "$DCOUNT" != "0" ]; then
		RECURSIVE="-R"
		echo "setfacl $RECURSIVE -m g:admin:rwx $HOMETEACHERS"
		setfacl $RECURSIVE -m g:admin:rwx $HOMETEACHERS || true
	fi
	echo "setfacl $RECURSIVE -d -m g:admin:rwx $HOMETEACHERS"
	setfacl $RECURSIVE -d -m g:admin:rwx $HOMETEACHERS || true
	echo "setfacl $RECURSIVE -d -m u::rwx $HOMETEACHERS"
	setfacl $RECURSIVE -d -m u::rwx $HOMETEACHERS || true
	echo "setfacl $RECURSIVE -d -m g::--- $HOMETEACHERS"
	setfacl $RECURSIVE -d -m g::--- $HOMETEACHERS || true
	echo "setfacl $RECURSIVE -d -m o::--- $HOMETEACHERS"
	setfacl $RECURSIVE -d -m o::--- $HOMETEACHERS || true
	echo "setfacl $RECURSIVE -d -m m::rwx $HOMETEACHERS"
	setfacl $RECURSIVE -d -m m::rwx $HOMETEACHERS || true
	touch $PATH_TO_TOKENS_LDAP_NET
}

_fix_acl_net_share(){
    NETSHARE="/net/share"
    mkdir -p $NETSHARE
    touch 	$NETSHARE/token_acl
    [ -d "$NETSHARE" ] || mkdir -p "$NETSHARE"
    DCOUNT="$(ls "$NETSHARE" | wc -w)"
    setfacl -k -b -R $NETSHARE || true
    if [ "$DCOUNT" != "0" ]; then
            RECURSIVE="-R"
            echo "setfacl $RECURSIVE -m g:teachers:rwx $NETSHARE"
            setfacl $RECURSIVE -m g:teachers:rwx $NETSHARE || true
            echo "setfacl $RECURSIVE -m g:admin:rwx $NETSHARE"
            setfacl $RECURSIVE -m g:admin:rwx $NETSHARE || true
            echo "setfacl $RECURSIVE -m g:students:rx $NETSHARE"
            setfacl $RECURSIVE -m g:students:rx $NETSHARE || true
            echo "setfacl $RECURSIVE -m g:www-data:rx $NETSHARE"
            setfacl $RECURSIVE -m g:www-data:rx $NETSHARE || true
    fi
    echo "setfacl $RECURSIVE -d -m g:www-data:rx $NETSHARE"
    setfacl $RECURSIVE -d -m g:www-data:rx $NETSHARE || true
    echo "setfacl $RECURSIVE -d -m g:teachers:rwx $NETSHARE"
    setfacl $RECURSIVE -d -m g:teachers:rwx $NETSHARE || true
    echo "setfacl $RECURSIVE -d -m g:admin:rwx $NETSHARE"
    setfacl $RECURSIVE -d -m g:admin:rwx $NETSHARE || true
    echo "setfacl $RECURSIVE -d -m g:students:rx $NETSHARE"
    setfacl $RECURSIVE -d -m g:students:rx $NETSHARE || true
    echo "setfacl $RECURSIVE -d -m u::rwx $NETSHARE"
    setfacl $RECURSIVE -d -m u::rwx $NETSHARE || true
    echo "setfacl $RECURSIVE -d -m g::--- $NETSHARE"
    setfacl $RECURSIVE -d -m g::--- $NETSHARE || true
    echo "setfacl $RECURSIVE -d -m o::--- $NETSHARE"
    setfacl $RECURSIVE -d -m o::--- $NETSHARE || true
    echo "setfacl $RECURSIVE -d -m m::rwx $NETSHARE"
    setfacl $RECURSIVE -d -m m::rwx $NETSHARE || true	
}

_fix_perm_net()
{
    NET_PATH="/net/home"
    chmod 755 "${NET_PATH}/students"
    chmod 755 "${NET_PATH}/others"
    chmod 755 "${NET_PATH}/teachers"
    for AUX_FILE in $(ls ${NET_PATH}/students); do
        echo "chmod 770 "${NET_PATH}/students/${AUX_FILE}""
        chmod 770 "${NET_PATH}/students/${AUX_FILE}"
    done
    for AUX_FILE in $(ls ${NET_PATH}/others); do
        echo "chmod 770 "${NET_PATH}/others/${AUX_FILE}""
        chmod 770 "${NET_PATH}/others/${AUX_FILE}"
    done
    for AUX_FILE in $(ls ${NET_PATH}/teachers); do
        echo "chmod 770 "${NET_PATH}/teachers/${AUX_FILE}""
        chmod 770 "${NET_PATH}/teachers/${AUX_FILE}"
    done
}
_fix_perm_net_share()
{
    NET_PATH="/net/share"
    chmod 770 $NET_PATH
    echo "chmod 770 $NET_PATH"
}
_fix_perm_net_group()
{
    chmod 775 /net/group
    for name_group in $(ls /net/group); do
        aux_group="/net/group/$name_group"
        chmod 755 $aux_group
        echo "chmod 755 $aux_group"
        for name_file in $(ls $aux_group); do
            echo "chmod 777 "${aux_group}/$name_file""
            chmod 777 "${aux_group}/$name_file"
        done
    done
}

_fix_owner_net()
{
    NET_PATH='/net/home'
    for DIRECTORY in $(ls "$NET_PATH/students"); do
        MAYBE_OWNER="$(stat -c '%U' "${NET_PATH}/students/${DIRECTORY}")"
        TRUE_OWNER="$DIRECTORY"
        echo "chown $TRUE_OWNER:students ${NET_PATH}/students/${DIRECTORY}"
  #      chown $TRUE_OWNER:students "${NET_PATH}/students/${DIRECTORY}"
        for FILE_CHANGE in $(find ${NET_PATH}/students/${DIRECTORY}/*); do
            TEMP_OWNER="$(stat -c '%U' "$FILE_CHANGE")"
            if [ "$MAYBE_OWNER" = "$TEMP_OWNER" ]; then
                echo "chown $TRUE_OWNER:students $FILE_CHANGE"
 #               chown $TRUE_OWNER:students "$FILE_CHANGE"
            fi
        done
    done
    for DIRECTORY in $(ls "$NET_PATH/teachers"); do
        MAYBE_OWNER="$(stat -c '%U' ${NET_PATH}/teachers/${DIRECTORY})"
        TRUE_OWNER="$DIRECTORY"
        echo "chown $TRUE_OWNER:teachers ${NET_PATH}/teachers/${DIRECTORY}"
#        chown $TRUE_OWNER:teachers "${NET_PATH}/teachers/${DIRECTORY}"
        for FILE_CHANGE in $(find ${NET_PATH}/teachers/${DIRECTORY}/*); do
            TEMP_OWNER="$(stat -c '%U' $FILE_CHANGE)"
            if [ "$MAYBE_OWNER" = "$TEMP_OWNER" ]; then
                echo "chown $TRUE_OWNER:teachers $FILE_CHANGE"
#                chown $TRUE_OWNER:teachers "$FILE_CHANGE"
            fi
        done
    done
    for DIRECTORY in $(ls "$NET_PATH/others"); do
        MAYBE_OWNER="$(stat -c '%U' ${NET_PATH}/others/${DIRECTORY})"
        TRUE_OWNER="$DIRECTORY"
        echo "chown $TRUE_OWNER:others ${NET_PATH}/others/${DIRECTORY}"
#        chown $TRUE_OWNER:others "${NET_PATH}/others/${DIRECTORY}"
        for FILE_CHANGE in $(find ${NET_PATH}/others/${DIRECTORY}/*); do
            TEMP_OWNER="$(stat -c '%U' $FILE_CHANGE)"
            if [ "$MAYBE_OWNER" = "$TEMP_OWNER" ]; then
                echo "chown $TRUE_OWNER:others $FILE_CHANGE"
                #chown $TRUE_OWNER:others "$FILE_CHANGE"
            fi
        done
    done
}

usage()
{
echo -e "\n\nUsage:"
    echo "magic-acl acl-home : Fix acl for /net/home"
    echo "magic-acl acl-share : Fix acl for /net/share"
    echo "magic-acl perm-home : Fix unix permission for /net/home"
    echo "magic-acl perm-share : Fix unix permission for /net/share"
    echo "magic-acl perm-group : Fix unix permission for /net/group"
    echo "magic-acl owner-net : change owner and group for /net/home folder to correctly user and group. (Only user files and directories)"
echo -e "\n\n"
}

case $1 in
    acl-home)
        _set_acls_net
    ;;
    acl-share)
        _fix_acl_net_share
    ;;
    perm-home)
        _fix_perm_net
    ;;
    perm-share)
        _fix_perm_net_share
    ;;
    perm-group)
        _fix_perm_net_group
    ;;
    owner-net)
        _fix_owner_net
    ;;
    *)
        usage
    ;;
esac
